commit acafa14b1a64d8b9fc4b69fe5d6e275a3afc513b
Author: Loki <654612@qq.com>
Date: Fri Sep 9 19:09:14 2022 +0800
init
diff --git a/.gitignore b/.gitignore
new file mode 100644
index 0000000..549e00a
--- /dev/null
+++ b/.gitignore
@@ -0,0 +1,33 @@
+HELP.md
+target/
+!.mvn/wrapper/maven-wrapper.jar
+!**/src/main/**/target/
+!**/src/test/**/target/
+
+### STS ###
+.apt_generated
+.classpath
+.factorypath
+.project
+.settings
+.springBeans
+.sts4-cache
+
+### IntelliJ IDEA ###
+.idea
+*.iws
+*.iml
+*.ipr
+
+### NetBeans ###
+/nbproject/private/
+/nbbuild/
+/dist/
+/nbdist/
+/.nb-gradle/
+build/
+!**/src/main/**/build/
+!**/src/test/**/build/
+
+### VS Code ###
+.vscode/
diff --git a/.mvn/wrapper/maven-wrapper.jar b/.mvn/wrapper/maven-wrapper.jar
new file mode 100644
index 0000000..c1dd12f
Binary files /dev/null and b/.mvn/wrapper/maven-wrapper.jar differ
diff --git a/.mvn/wrapper/maven-wrapper.properties b/.mvn/wrapper/maven-wrapper.properties
new file mode 100644
index 0000000..22f219d
--- /dev/null
+++ b/.mvn/wrapper/maven-wrapper.properties
@@ -0,0 +1,2 @@
+distributionUrl=https://repo.maven.apache.org/maven2/org/apache/maven/apache-maven/3.8.5/apache-maven-3.8.5-bin.zip
+wrapperUrl=https://repo.maven.apache.org/maven2/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar
diff --git a/mvnw b/mvnw
new file mode 100644
index 0000000..8a8fb22
--- /dev/null
+++ b/mvnw
@@ -0,0 +1,316 @@
+#!/bin/sh
+# ----------------------------------------------------------------------------
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements. See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership. The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License. You may obtain a copy of the License at
+#
+# https://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied. See the License for the
+# specific language governing permissions and limitations
+# under the License.
+# ----------------------------------------------------------------------------
+
+# ----------------------------------------------------------------------------
+# Maven Start Up Batch script
+#
+# Required ENV vars:
+# ------------------
+# JAVA_HOME - location of a JDK home dir
+#
+# Optional ENV vars
+# -----------------
+# M2_HOME - location of maven2's installed home dir
+# MAVEN_OPTS - parameters passed to the Java VM when running Maven
+# e.g. to debug Maven itself, use
+# set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+# MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+# ----------------------------------------------------------------------------
+
+if [ -z "$MAVEN_SKIP_RC" ] ; then
+
+ if [ -f /usr/local/etc/mavenrc ] ; then
+ . /usr/local/etc/mavenrc
+ fi
+
+ if [ -f /etc/mavenrc ] ; then
+ . /etc/mavenrc
+ fi
+
+ if [ -f "$HOME/.mavenrc" ] ; then
+ . "$HOME/.mavenrc"
+ fi
+
+fi
+
+# OS specific support. $var _must_ be set to either true or false.
+cygwin=false;
+darwin=false;
+mingw=false
+case "`uname`" in
+ CYGWIN*) cygwin=true ;;
+ MINGW*) mingw=true;;
+ Darwin*) darwin=true
+ # Use /usr/libexec/java_home if available, otherwise fall back to /Library/Java/Home
+ # See https://developer.apple.com/library/mac/qa/qa1170/_index.html
+ if [ -z "$JAVA_HOME" ]; then
+ if [ -x "/usr/libexec/java_home" ]; then
+ export JAVA_HOME="`/usr/libexec/java_home`"
+ else
+ export JAVA_HOME="/Library/Java/Home"
+ fi
+ fi
+ ;;
+esac
+
+if [ -z "$JAVA_HOME" ] ; then
+ if [ -r /etc/gentoo-release ] ; then
+ JAVA_HOME=`java-config --jre-home`
+ fi
+fi
+
+if [ -z "$M2_HOME" ] ; then
+ ## resolve links - $0 may be a link to maven's home
+ PRG="$0"
+
+ # need this for relative symlinks
+ while [ -h "$PRG" ] ; do
+ ls=`ls -ld "$PRG"`
+ link=`expr "$ls" : '.*-> \(.*\)$'`
+ if expr "$link" : '/.*' > /dev/null; then
+ PRG="$link"
+ else
+ PRG="`dirname "$PRG"`/$link"
+ fi
+ done
+
+ saveddir=`pwd`
+
+ M2_HOME=`dirname "$PRG"`/..
+
+ # make it fully qualified
+ M2_HOME=`cd "$M2_HOME" && pwd`
+
+ cd "$saveddir"
+ # echo Using m2 at $M2_HOME
+fi
+
+# For Cygwin, ensure paths are in UNIX format before anything is touched
+if $cygwin ; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=`cygpath --unix "$M2_HOME"`
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=`cygpath --unix "$JAVA_HOME"`
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=`cygpath --path --unix "$CLASSPATH"`
+fi
+
+# For Mingw, ensure paths are in UNIX format before anything is touched
+if $mingw ; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME="`(cd "$M2_HOME"; pwd)`"
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME="`(cd "$JAVA_HOME"; pwd)`"
+fi
+
+if [ -z "$JAVA_HOME" ]; then
+ javaExecutable="`which javac`"
+ if [ -n "$javaExecutable" ] && ! [ "`expr \"$javaExecutable\" : '\([^ ]*\)'`" = "no" ]; then
+ # readlink(1) is not available as standard on Solaris 10.
+ readLink=`which readlink`
+ if [ ! `expr "$readLink" : '\([^ ]*\)'` = "no" ]; then
+ if $darwin ; then
+ javaHome="`dirname \"$javaExecutable\"`"
+ javaExecutable="`cd \"$javaHome\" && pwd -P`/javac"
+ else
+ javaExecutable="`readlink -f \"$javaExecutable\"`"
+ fi
+ javaHome="`dirname \"$javaExecutable\"`"
+ javaHome=`expr "$javaHome" : '\(.*\)/bin'`
+ JAVA_HOME="$javaHome"
+ export JAVA_HOME
+ fi
+ fi
+fi
+
+if [ -z "$JAVACMD" ] ; then
+ if [ -n "$JAVA_HOME" ] ; then
+ if [ -x "$JAVA_HOME/jre/sh/java" ] ; then
+ # IBM's JDK on AIX uses strange locations for the executables
+ JAVACMD="$JAVA_HOME/jre/sh/java"
+ else
+ JAVACMD="$JAVA_HOME/bin/java"
+ fi
+ else
+ JAVACMD="`\\unset -f command; \\command -v java`"
+ fi
+fi
+
+if [ ! -x "$JAVACMD" ] ; then
+ echo "Error: JAVA_HOME is not defined correctly." >&2
+ echo " We cannot execute $JAVACMD" >&2
+ exit 1
+fi
+
+if [ -z "$JAVA_HOME" ] ; then
+ echo "Warning: JAVA_HOME environment variable is not set."
+fi
+
+CLASSWORLDS_LAUNCHER=org.codehaus.plexus.classworlds.launcher.Launcher
+
+# traverses directory structure from process work directory to filesystem root
+# first directory with .mvn subdirectory is considered project base directory
+find_maven_basedir() {
+
+ if [ -z "$1" ]
+ then
+ echo "Path not specified to find_maven_basedir"
+ return 1
+ fi
+
+ basedir="$1"
+ wdir="$1"
+ while [ "$wdir" != '/' ] ; do
+ if [ -d "$wdir"/.mvn ] ; then
+ basedir=$wdir
+ break
+ fi
+ # workaround for JBEAP-8937 (on Solaris 10/Sparc)
+ if [ -d "${wdir}" ]; then
+ wdir=`cd "$wdir/.."; pwd`
+ fi
+ # end of workaround
+ done
+ echo "${basedir}"
+}
+
+# concatenates all lines of a file
+concat_lines() {
+ if [ -f "$1" ]; then
+ echo "$(tr -s '\n' ' ' < "$1")"
+ fi
+}
+
+BASE_DIR=`find_maven_basedir "$(pwd)"`
+if [ -z "$BASE_DIR" ]; then
+ exit 1;
+fi
+
+##########################################################################################
+# Extension to allow automatically downloading the maven-wrapper.jar from Maven-central
+# This allows using the maven wrapper in projects that prohibit checking in binary data.
+##########################################################################################
+if [ -r "$BASE_DIR/.mvn/wrapper/maven-wrapper.jar" ]; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found .mvn/wrapper/maven-wrapper.jar"
+ fi
+else
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Couldn't find .mvn/wrapper/maven-wrapper.jar, downloading it ..."
+ fi
+ if [ -n "$MVNW_REPOURL" ]; then
+ jarUrl="$MVNW_REPOURL/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+ else
+ jarUrl="https://repo.maven.apache.org/maven2/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+ fi
+ while IFS="=" read key value; do
+ case "$key" in (wrapperUrl) jarUrl="$value"; break ;;
+ esac
+ done < "$BASE_DIR/.mvn/wrapper/maven-wrapper.properties"
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Downloading from: $jarUrl"
+ fi
+ wrapperJarPath="$BASE_DIR/.mvn/wrapper/maven-wrapper.jar"
+ if $cygwin; then
+ wrapperJarPath=`cygpath --path --windows "$wrapperJarPath"`
+ fi
+
+ if command -v wget > /dev/null; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found wget ... using wget"
+ fi
+ if [ -z "$MVNW_USERNAME" ] || [ -z "$MVNW_PASSWORD" ]; then
+ wget "$jarUrl" -O "$wrapperJarPath" || rm -f "$wrapperJarPath"
+ else
+ wget --http-user=$MVNW_USERNAME --http-password=$MVNW_PASSWORD "$jarUrl" -O "$wrapperJarPath" || rm -f "$wrapperJarPath"
+ fi
+ elif command -v curl > /dev/null; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found curl ... using curl"
+ fi
+ if [ -z "$MVNW_USERNAME" ] || [ -z "$MVNW_PASSWORD" ]; then
+ curl -o "$wrapperJarPath" "$jarUrl" -f
+ else
+ curl --user $MVNW_USERNAME:$MVNW_PASSWORD -o "$wrapperJarPath" "$jarUrl" -f
+ fi
+
+ else
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Falling back to using Java to download"
+ fi
+ javaClass="$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.java"
+ # For Cygwin, switch paths to Windows format before running javac
+ if $cygwin; then
+ javaClass=`cygpath --path --windows "$javaClass"`
+ fi
+ if [ -e "$javaClass" ]; then
+ if [ ! -e "$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.class" ]; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo " - Compiling MavenWrapperDownloader.java ..."
+ fi
+ # Compiling the Java class
+ ("$JAVA_HOME/bin/javac" "$javaClass")
+ fi
+ if [ -e "$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.class" ]; then
+ # Running the downloader
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo " - Running MavenWrapperDownloader.java ..."
+ fi
+ ("$JAVA_HOME/bin/java" -cp .mvn/wrapper MavenWrapperDownloader "$MAVEN_PROJECTBASEDIR")
+ fi
+ fi
+ fi
+fi
+##########################################################################################
+# End of extension
+##########################################################################################
+
+export MAVEN_PROJECTBASEDIR=${MAVEN_BASEDIR:-"$BASE_DIR"}
+if [ "$MVNW_VERBOSE" = true ]; then
+ echo $MAVEN_PROJECTBASEDIR
+fi
+MAVEN_OPTS="$(concat_lines "$MAVEN_PROJECTBASEDIR/.mvn/jvm.config") $MAVEN_OPTS"
+
+# For Cygwin, switch paths to Windows format before running java
+if $cygwin; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=`cygpath --path --windows "$M2_HOME"`
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=`cygpath --path --windows "$JAVA_HOME"`
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=`cygpath --path --windows "$CLASSPATH"`
+ [ -n "$MAVEN_PROJECTBASEDIR" ] &&
+ MAVEN_PROJECTBASEDIR=`cygpath --path --windows "$MAVEN_PROJECTBASEDIR"`
+fi
+
+# Provide a "standardized" way to retrieve the CLI args that will
+# work with both Windows and non-Windows executions.
+MAVEN_CMD_LINE_ARGS="$MAVEN_CONFIG $@"
+export MAVEN_CMD_LINE_ARGS
+
+WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+exec "$JAVACMD" \
+ $MAVEN_OPTS \
+ $MAVEN_DEBUG_OPTS \
+ -classpath "$MAVEN_PROJECTBASEDIR/.mvn/wrapper/maven-wrapper.jar" \
+ "-Dmaven.home=${M2_HOME}" \
+ "-Dmaven.multiModuleProjectDirectory=${MAVEN_PROJECTBASEDIR}" \
+ ${WRAPPER_LAUNCHER} $MAVEN_CONFIG "$@"
diff --git a/mvnw.cmd b/mvnw.cmd
new file mode 100644
index 0000000..1d8ab01
--- /dev/null
+++ b/mvnw.cmd
@@ -0,0 +1,188 @@
+@REM ----------------------------------------------------------------------------
+@REM Licensed to the Apache Software Foundation (ASF) under one
+@REM or more contributor license agreements. See the NOTICE file
+@REM distributed with this work for additional information
+@REM regarding copyright ownership. The ASF licenses this file
+@REM to you under the Apache License, Version 2.0 (the
+@REM "License"); you may not use this file except in compliance
+@REM with the License. You may obtain a copy of the License at
+@REM
+@REM https://www.apache.org/licenses/LICENSE-2.0
+@REM
+@REM Unless required by applicable law or agreed to in writing,
+@REM software distributed under the License is distributed on an
+@REM "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+@REM KIND, either express or implied. See the License for the
+@REM specific language governing permissions and limitations
+@REM under the License.
+@REM ----------------------------------------------------------------------------
+
+@REM ----------------------------------------------------------------------------
+@REM Maven Start Up Batch script
+@REM
+@REM Required ENV vars:
+@REM JAVA_HOME - location of a JDK home dir
+@REM
+@REM Optional ENV vars
+@REM M2_HOME - location of maven2's installed home dir
+@REM MAVEN_BATCH_ECHO - set to 'on' to enable the echoing of the batch commands
+@REM MAVEN_BATCH_PAUSE - set to 'on' to wait for a keystroke before ending
+@REM MAVEN_OPTS - parameters passed to the Java VM when running Maven
+@REM e.g. to debug Maven itself, use
+@REM set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+@REM MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+@REM ----------------------------------------------------------------------------
+
+@REM Begin all REM lines with '@' in case MAVEN_BATCH_ECHO is 'on'
+@echo off
+@REM set title of command window
+title %0
+@REM enable echoing by setting MAVEN_BATCH_ECHO to 'on'
+@if "%MAVEN_BATCH_ECHO%" == "on" echo %MAVEN_BATCH_ECHO%
+
+@REM set %HOME% to equivalent of $HOME
+if "%HOME%" == "" (set "HOME=%HOMEDRIVE%%HOMEPATH%")
+
+@REM Execute a user defined script before this one
+if not "%MAVEN_SKIP_RC%" == "" goto skipRcPre
+@REM check for pre script, once with legacy .bat ending and once with .cmd ending
+if exist "%USERPROFILE%\mavenrc_pre.bat" call "%USERPROFILE%\mavenrc_pre.bat" %*
+if exist "%USERPROFILE%\mavenrc_pre.cmd" call "%USERPROFILE%\mavenrc_pre.cmd" %*
+:skipRcPre
+
+@setlocal
+
+set ERROR_CODE=0
+
+@REM To isolate internal variables from possible post scripts, we use another setlocal
+@setlocal
+
+@REM ==== START VALIDATION ====
+if not "%JAVA_HOME%" == "" goto OkJHome
+
+echo.
+echo Error: JAVA_HOME not found in your environment. >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+:OkJHome
+if exist "%JAVA_HOME%\bin\java.exe" goto init
+
+echo.
+echo Error: JAVA_HOME is set to an invalid directory. >&2
+echo JAVA_HOME = "%JAVA_HOME%" >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+@REM ==== END VALIDATION ====
+
+:init
+
+@REM Find the project base dir, i.e. the directory that contains the folder ".mvn".
+@REM Fallback to current working directory if not found.
+
+set MAVEN_PROJECTBASEDIR=%MAVEN_BASEDIR%
+IF NOT "%MAVEN_PROJECTBASEDIR%"=="" goto endDetectBaseDir
+
+set EXEC_DIR=%CD%
+set WDIR=%EXEC_DIR%
+:findBaseDir
+IF EXIST "%WDIR%"\.mvn goto baseDirFound
+cd ..
+IF "%WDIR%"=="%CD%" goto baseDirNotFound
+set WDIR=%CD%
+goto findBaseDir
+
+:baseDirFound
+set MAVEN_PROJECTBASEDIR=%WDIR%
+cd "%EXEC_DIR%"
+goto endDetectBaseDir
+
+:baseDirNotFound
+set MAVEN_PROJECTBASEDIR=%EXEC_DIR%
+cd "%EXEC_DIR%"
+
+:endDetectBaseDir
+
+IF NOT EXIST "%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config" goto endReadAdditionalConfig
+
+@setlocal EnableExtensions EnableDelayedExpansion
+for /F "usebackq delims=" %%a in ("%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config") do set JVM_CONFIG_MAVEN_PROPS=!JVM_CONFIG_MAVEN_PROPS! %%a
+@endlocal & set JVM_CONFIG_MAVEN_PROPS=%JVM_CONFIG_MAVEN_PROPS%
+
+:endReadAdditionalConfig
+
+SET MAVEN_JAVA_EXE="%JAVA_HOME%\bin\java.exe"
+set WRAPPER_JAR="%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.jar"
+set WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+set DOWNLOAD_URL="https://repo.maven.apache.org/maven2/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+
+FOR /F "usebackq tokens=1,2 delims==" %%A IN ("%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.properties") DO (
+ IF "%%A"=="wrapperUrl" SET DOWNLOAD_URL=%%B
+)
+
+@REM Extension to allow automatically downloading the maven-wrapper.jar from Maven-central
+@REM This allows using the maven wrapper in projects that prohibit checking in binary data.
+if exist %WRAPPER_JAR% (
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Found %WRAPPER_JAR%
+ )
+) else (
+ if not "%MVNW_REPOURL%" == "" (
+ SET DOWNLOAD_URL="%MVNW_REPOURL%/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+ )
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Couldn't find %WRAPPER_JAR%, downloading it ...
+ echo Downloading from: %DOWNLOAD_URL%
+ )
+
+ powershell -Command "&{"^
+ "$webclient = new-object System.Net.WebClient;"^
+ "if (-not ([string]::IsNullOrEmpty('%MVNW_USERNAME%') -and [string]::IsNullOrEmpty('%MVNW_PASSWORD%'))) {"^
+ "$webclient.Credentials = new-object System.Net.NetworkCredential('%MVNW_USERNAME%', '%MVNW_PASSWORD%');"^
+ "}"^
+ "[Net.ServicePointManager]::SecurityProtocol = [Net.SecurityProtocolType]::Tls12; $webclient.DownloadFile('%DOWNLOAD_URL%', '%WRAPPER_JAR%')"^
+ "}"
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Finished downloading %WRAPPER_JAR%
+ )
+)
+@REM End of extension
+
+@REM Provide a "standardized" way to retrieve the CLI args that will
+@REM work with both Windows and non-Windows executions.
+set MAVEN_CMD_LINE_ARGS=%*
+
+%MAVEN_JAVA_EXE% ^
+ %JVM_CONFIG_MAVEN_PROPS% ^
+ %MAVEN_OPTS% ^
+ %MAVEN_DEBUG_OPTS% ^
+ -classpath %WRAPPER_JAR% ^
+ "-Dmaven.multiModuleProjectDirectory=%MAVEN_PROJECTBASEDIR%" ^
+ %WRAPPER_LAUNCHER% %MAVEN_CONFIG% %*
+if ERRORLEVEL 1 goto error
+goto end
+
+:error
+set ERROR_CODE=1
+
+:end
+@endlocal & set ERROR_CODE=%ERROR_CODE%
+
+if not "%MAVEN_SKIP_RC%"=="" goto skipRcPost
+@REM check for post script, once with legacy .bat ending and once with .cmd ending
+if exist "%USERPROFILE%\mavenrc_post.bat" call "%USERPROFILE%\mavenrc_post.bat"
+if exist "%USERPROFILE%\mavenrc_post.cmd" call "%USERPROFILE%\mavenrc_post.cmd"
+:skipRcPost
+
+@REM pause the script if MAVEN_BATCH_PAUSE is set to 'on'
+if "%MAVEN_BATCH_PAUSE%"=="on" pause
+
+if "%MAVEN_TERMINATE_CMD%"=="on" exit %ERROR_CODE%
+
+cmd /C exit /B %ERROR_CODE%
diff --git a/pom.xml b/pom.xml
new file mode 100644
index 0000000..d54cc2f
--- /dev/null
+++ b/pom.xml
@@ -0,0 +1,80 @@
+
+
+ 4.0.0
+
+ org.springframework.boot
+ spring-boot-starter-parent
+ 2.7.1
+
+
+ com.example
+ demo1
+ 0.0.1-SNAPSHOT
+ demo1
+ demo1
+
+
+
+
+
+ org.apache.qpid
+ qpid-jms-client
+ 1.6.0
+
+
+
+ cn.hutool
+ hutool-all
+ 5.8.0.M1
+
+
+
+
+ com.aliyun
+ iot20180120
+ 3.0.8
+
+
+
+
+ org.projectlombok
+ lombok
+ true
+
+
+
+ org.springframework.boot
+ spring-boot-starter-web
+
+
+
+ org.projectlombok
+ lombok
+ true
+
+
+ org.springframework.boot
+ spring-boot-starter-test
+ test
+
+
+
+
+
+
+ org.springframework.boot
+ spring-boot-maven-plugin
+
+
+
+ org.projectlombok
+ lombok
+
+
+
+
+
+
+
+
diff --git a/src/main/java/com/example/demo/AmqpClient.java b/src/main/java/com/example/demo/AmqpClient.java
new file mode 100644
index 0000000..cda5d86
--- /dev/null
+++ b/src/main/java/com/example/demo/AmqpClient.java
@@ -0,0 +1,225 @@
+package com.example.demo;
+
+
+import java.net.URI;
+import java.util.ArrayList;
+import java.util.Hashtable;
+import java.util.List;
+import java.util.concurrent.ExecutorService;
+import java.util.concurrent.LinkedBlockingQueue;
+import java.util.concurrent.ThreadPoolExecutor;
+import java.util.concurrent.TimeUnit;
+
+import javax.crypto.Mac;
+import javax.crypto.spec.SecretKeySpec;
+import javax.jms.Connection;
+import javax.jms.ConnectionFactory;
+import javax.jms.Destination;
+import javax.jms.JMSException;
+import javax.jms.Message;
+import javax.jms.MessageConsumer;
+import javax.jms.MessageListener;
+import javax.jms.MessageProducer;
+import javax.jms.Session;
+import javax.naming.Context;
+import javax.naming.InitialContext;
+
+import lombok.extern.slf4j.Slf4j;
+import org.apache.qpid.jms.JmsConnection;
+import org.apache.qpid.jms.JmsConnectionListener;
+import org.apache.qpid.jms.message.JmsInboundMessageDispatch;
+import org.apache.tomcat.util.codec.binary.Base64;
+
+
+@Slf4j
+public class AmqpClient {
+ private static String accessKey = "LTAI5t9DYVYpzxbmYBx3t4LU";
+ private static String accessSecret = "tM4EmXqeohWTxJ5R1AmsItai6zjiaQ";
+ private static String consumerGroupId = "DEFAULT_GROUP";
+
+ //iotInstanceId:实例ID。若是2021年07月30日之前(不含当日)开通的公共实例,请填空字符串。
+ private static String iotInstanceId = "iot-06z00hk8iq70r0s";
+
+ //控制台服务端订阅中消费组状态页客户端ID一栏将显示clientId参数。
+ //建议使用机器UUID、MAC地址、IP等唯一标识等作为clientId。便于您区分识别不同的客户端。
+ private static String clientId = "boom";
+
+ //${YourHost}为接入域名,请参见AMQP客户端接入说明文档。
+ private static String host = "iot-06z00hk8iq70r0s.amqp.iothub.aliyuncs.com";
+
+ // 指定单个进程启动的连接数
+ // 单个连接消费速率有限,请参考使用限制,最大64个连接
+ // 连接数和消费速率及rebalance相关,建议每500QPS增加一个连接
+ private static int connectionCount = 4;
+
+ //业务处理异步线程池,线程池参数可以根据您的业务特点调整,或者您也可以用其他异步方式处理接收到的消息。
+ private final static ExecutorService executorService = new ThreadPoolExecutor(
+ Runtime.getRuntime().availableProcessors(),
+ Runtime.getRuntime().availableProcessors() * 2, 60, TimeUnit.SECONDS,
+ new LinkedBlockingQueue(50000));
+
+ public static void main(String[] args) throws Exception {
+ List connections = new ArrayList<>();
+
+ //参数说明,请参见AMQP客户端接入说明文档。
+ for (int i = 0; i < connectionCount; i++) {
+ long timeStamp = System.currentTimeMillis();
+ //签名方法:支持hmacmd5、hmacsha1和hmacsha256。
+ String signMethod = "hmacsha1";
+
+ //userName组装方法,请参见AMQP客户端接入说明文档。
+ String userName = clientId + "-" + i + "|authMode=aksign"
+ + ",signMethod=" + signMethod
+ + ",timestamp=" + timeStamp
+ + ",authId=" + accessKey
+ + ",iotInstanceId=" + iotInstanceId
+ + ",consumerGroupId=" + consumerGroupId
+ + "|";
+ //计算签名,password组装方法,请参见AMQP客户端接入说明文档。
+ String signContent = "authId=" + accessKey + "×tamp=" + timeStamp;
+ String password = doSign(signContent, accessSecret, signMethod);
+ String connectionUrl = "failover:(amqps://" + host + ":5671?amqp.idleTimeout=80000)"
+ + "?failover.reconnectDelay=30";
+
+ Hashtable hashtable = new Hashtable<>();
+ hashtable.put("connectionfactory.SBCF", connectionUrl);
+ hashtable.put("queue.QUEUE", "default");
+ hashtable.put(Context.INITIAL_CONTEXT_FACTORY, "org.apache.qpid.jms.jndi.JmsInitialContextFactory");
+ Context context = new InitialContext(hashtable);
+ ConnectionFactory cf = (ConnectionFactory)context.lookup("SBCF");
+ Destination queue = (Destination)context.lookup("QUEUE");
+ // 创建连接。
+ Connection connection = cf.createConnection(userName, password);
+ connections.add(connection);
+
+ ((JmsConnection)connection).addConnectionListener(myJmsConnectionListener);
+ // 创建会话。
+ // Session.CLIENT_ACKNOWLEDGE: 收到消息后,需要手动调用message.acknowledge()。
+ // Session.AUTO_ACKNOWLEDGE: SDK自动ACK(推荐)。
+ Session session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);
+
+ connection.start();
+ // 创建Receiver连接。
+ MessageConsumer consumer = session.createConsumer(queue);
+ consumer.setMessageListener(messageListener);
+ }
+
+ log.info("amqp demo is started successfully, and will exit after 60s ");
+
+ // 结束程序运行
+ Thread.sleep(60 * 1000);
+ log.info("run shutdown");
+
+ connections.forEach(c-> {
+ try {
+ c.close();
+ } catch (JMSException e) {
+ log.error("failed to close connection", e);
+ }
+ });
+
+ executorService.shutdown();
+ if (executorService.awaitTermination(10, TimeUnit.SECONDS)) {
+ log.info("shutdown success");
+ } else {
+ log.info("failed to handle messages");
+ }
+ }
+
+ private static MessageListener messageListener = new MessageListener() {
+ @Override
+ public void onMessage(final Message message) {
+ try {
+ //1.收到消息之后一定要ACK。
+ // 推荐做法:创建Session选择Session.AUTO_ACKNOWLEDGE,这里会自动ACK。
+ // 其他做法:创建Session选择Session.CLIENT_ACKNOWLEDGE,这里一定要调message.acknowledge()来ACK。
+ // message.acknowledge();
+ //2.建议异步处理收到的消息,确保onMessage函数里没有耗时逻辑。
+ // 如果业务处理耗时过程过长阻塞住线程,可能会影响SDK收到消息后的正常回调。
+ executorService.submit(new Runnable() {
+ @Override
+ public void run() {
+ processMessage(message);
+ }
+ });
+ } catch (Exception e) {
+ log.error("submit task occurs exception ", e);
+ }
+ }
+ };
+
+ /**
+ * 在这里处理您收到消息后的具体业务逻辑。
+ */
+ private static void processMessage(Message message) {
+ try {
+ byte[] body = message.getBody(byte[].class);
+ String content = new String(body);
+ String topic = message.getStringProperty("topic");
+ String messageId = message.getStringProperty("messageId");
+ log.info("receive message"
+ + ",\n topic = " + topic
+ + ",\n messageId = " + messageId
+ + ",\n content = " + content);
+ } catch (Exception e) {
+ log.error("processMessage occurs error ", e);
+ }
+ }
+
+ private static JmsConnectionListener myJmsConnectionListener = new JmsConnectionListener() {
+ /**
+ * 连接成功建立。
+ */
+ @Override
+ public void onConnectionEstablished(URI remoteURI) {
+ log.info("onConnectionEstablished, remoteUri:{}", remoteURI);
+ }
+
+ /**
+ * 尝试过最大重试次数之后,最终连接失败。
+ */
+ @Override
+ public void onConnectionFailure(Throwable error) {
+ log.error("onConnectionFailure, {}", error.getMessage());
+ }
+
+ /**
+ * 连接中断。
+ */
+ @Override
+ public void onConnectionInterrupted(URI remoteURI) {
+ log.info("onConnectionInterrupted, remoteUri:{}", remoteURI);
+ }
+
+ /**
+ * 连接中断后又自动重连上。
+ */
+ @Override
+ public void onConnectionRestored(URI remoteURI) {
+ log.info("onConnectionRestored, remoteUri:{}", remoteURI);
+ }
+
+ @Override
+ public void onInboundMessage(JmsInboundMessageDispatch envelope) {}
+
+ @Override
+ public void onSessionClosed(Session session, Throwable cause) {}
+
+ @Override
+ public void onConsumerClosed(MessageConsumer consumer, Throwable cause) {}
+
+ @Override
+ public void onProducerClosed(MessageProducer producer, Throwable cause) {}
+ };
+
+ /**
+ * 计算签名,password组装方法,请参见AMQP客户端接入说明文档。
+ */
+ private static String doSign(String toSignString, String secret, String signMethod) throws Exception {
+ SecretKeySpec signingKey = new SecretKeySpec(secret.getBytes(), signMethod);
+ Mac mac = Mac.getInstance(signMethod);
+ mac.init(signingKey);
+ byte[] rawHmac = mac.doFinal(toSignString.getBytes());
+ return Base64.encodeBase64String(rawHmac);
+ }
+}
diff --git a/src/main/java/com/example/demo/Demo1Application.java b/src/main/java/com/example/demo/Demo1Application.java
new file mode 100644
index 0000000..6100d37
--- /dev/null
+++ b/src/main/java/com/example/demo/Demo1Application.java
@@ -0,0 +1,13 @@
+package com.example.demo;
+
+import org.springframework.boot.SpringApplication;
+import org.springframework.boot.autoconfigure.SpringBootApplication;
+
+@SpringBootApplication
+public class Demo1Application {
+
+ public static void main(String[] args) {
+ SpringApplication.run(Demo1Application.class, args);
+ }
+
+}
diff --git a/src/main/java/com/example/demo/config/AliMqttConfig.java b/src/main/java/com/example/demo/config/AliMqttConfig.java
new file mode 100644
index 0000000..4e6ec63
--- /dev/null
+++ b/src/main/java/com/example/demo/config/AliMqttConfig.java
@@ -0,0 +1,26 @@
+package com.example.demo.config;
+
+
+import com.aliyun.iot20180120.Client;
+import com.aliyun.teaopenapi.models.Config;
+import lombok.extern.slf4j.Slf4j;
+import org.springframework.context.annotation.Bean;
+import org.springframework.context.annotation.Configuration;
+
+@Configuration
+@Slf4j
+public class AliMqttConfig {
+
+ private String accessKey = "LTAI5t9DYVYpzxbmYBx3t4LU";
+
+ private String accessSecret = "tM4EmXqeohWTxJ5R1AmsItai6zjiaQ";
+
+ @Bean
+ public Client config() throws Exception {
+ Config config = new Config();
+ config.setAccessKeyId(accessKey);
+ config.setAccessKeySecret(accessSecret);
+ config.setRegionId("cn-shanghai");
+ return new Client(config);
+ }
+}
diff --git a/src/main/java/com/example/demo/config/AmqpConfig.java b/src/main/java/com/example/demo/config/AmqpConfig.java
new file mode 100644
index 0000000..9370e65
--- /dev/null
+++ b/src/main/java/com/example/demo/config/AmqpConfig.java
@@ -0,0 +1,106 @@
+package com.example.demo.config;
+
+import lombok.extern.slf4j.Slf4j;
+import org.apache.qpid.jms.JmsConnection;
+import org.apache.qpid.jms.JmsConnectionListener;
+import org.apache.qpid.jms.message.JmsInboundMessageDispatch;
+import org.apache.tomcat.util.codec.binary.Base64;
+import org.springframework.context.annotation.Bean;
+import org.springframework.context.annotation.Configuration;
+
+import javax.crypto.Mac;
+import javax.crypto.spec.SecretKeySpec;
+import javax.jms.*;
+import javax.naming.Context;
+import javax.naming.InitialContext;
+import javax.naming.NamingException;
+import java.net.URI;
+import java.util.Hashtable;
+
+//@Configuration
+@Slf4j
+public class AmqpConfig {
+
+ private String accessKey = "LTAI5t9DYVYpzxbmYBx3t4LU";
+
+ private String accessSecret = "tM4EmXqeohWTxJ5R1AmsItai6zjiaQ";
+
+ private String groupId = "DEFAULT_GROUP";
+
+ private String clientId = "zyh";
+ private String iotInstanceId = "iot-06z00hk8iq70r0s";
+ private String host = "iot-06z00hk8iq70r0s.amqp.iothub.aliyuncs.com";
+
+ @Bean
+ public Session consumer() throws Exception {
+
+ log.info("start...");
+
+ String signMethod = "hmacsha1";
+
+ long timeStamp = System.currentTimeMillis();
+ //userName组装方法,请参见AMQP客户端接入说明文档。
+ String userName = clientId + "|authMode=aksign"
+ + ",signMethod=" + signMethod
+ + ",timestamp=" + timeStamp
+ + ",authId=" + accessKey
+ + ",iotInstanceId=" + iotInstanceId
+ + ",consumerGroupId=" + groupId
+ + "|";
+ log.info("username:{}",userName);
+ //计算签名,password组装方法,请参见AMQP客户端接入说明文档。
+ String signContent = "authId=" + accessKey + "×tamp=" + timeStamp;
+ String password = doSign(signContent, accessSecret, signMethod);
+ String connectionUrl = "failover:(amqps://" + host + ":5671?amqp.idleTimeout=80000)"
+ + "?failover.reconnectDelay=30";
+
+
+ Hashtable hashtable = new Hashtable<>();
+ hashtable.put("connectionfactory.URL", connectionUrl);
+ hashtable.put("queue.QUEUE", "default");
+ hashtable.put("queue.ZYH", "default");
+ hashtable.put(Context.INITIAL_CONTEXT_FACTORY, "org.apache.qpid.jms.jndi.JmsInitialContextFactory");
+
+ Context context = new InitialContext(hashtable);
+
+ ConnectionFactory connectionFactory = (ConnectionFactory) context.lookup("URL");
+ Destination queue = (Destination) context.lookup("QUEUE");
+
+ Connection connection = connectionFactory.createConnection(userName,password);
+
+ ((JmsConnection) connection).addConnectionListener(new ConnectListener());
+
+ Session session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);
+ connection.start();
+
+ MessageConsumer consumer = session.createConsumer(queue);
+
+ consumer.setMessageListener(message -> {
+ try {
+ byte[] body = message.getBody(byte[].class);
+ String content = new String(body);
+ String topic = message.getStringProperty("topic");
+ String messageId = message.getStringProperty("messageId");
+ log.info("receive message"
+ + ",\n topic = " + topic
+ + ",\n messageId = " + messageId
+ + ",\n content = " + content);
+ } catch (Exception e) {
+ log.error("processMessage occurs error ", e);
+ }
+ });
+
+ return session;
+
+ }
+
+ private static String doSign(String toSignString, String secret, String signMethod) throws Exception {
+ SecretKeySpec signingKey = new SecretKeySpec(secret.getBytes(), signMethod);
+ Mac mac = Mac.getInstance(signMethod);
+ mac.init(signingKey);
+ byte[] rawHmac = mac.doFinal(toSignString.getBytes());
+ return Base64.encodeBase64String(rawHmac);
+ }
+
+
+}
\ No newline at end of file
diff --git a/src/main/java/com/example/demo/config/ConnectListener.java b/src/main/java/com/example/demo/config/ConnectListener.java
new file mode 100644
index 0000000..202f101
--- /dev/null
+++ b/src/main/java/com/example/demo/config/ConnectListener.java
@@ -0,0 +1,58 @@
+package com.example.demo.config;
+
+import lombok.extern.slf4j.Slf4j;
+import org.apache.qpid.jms.JmsConnectionListener;
+import org.apache.qpid.jms.message.JmsInboundMessageDispatch;
+
+import javax.jms.MessageConsumer;
+import javax.jms.MessageProducer;
+import javax.jms.Session;
+import java.net.URI;
+
+@Slf4j
+public class ConnectListener implements JmsConnectionListener {
+
+ public ConnectListener() {
+ log.info("ConnectListener init...");
+ }
+
+ @Override
+ public void onConnectionEstablished(URI uri) {
+ log.error("uri:{}",uri);
+ }
+
+ @Override
+ public void onConnectionFailure(Throwable throwable) {
+ throwable.printStackTrace();
+ }
+
+ @Override
+ public void onConnectionInterrupted(URI uri) {
+ log.error("uri:{}",uri);
+ }
+
+ @Override
+ public void onConnectionRestored(URI uri) {
+ log.error("uri:{}",uri);
+ }
+
+ @Override
+ public void onInboundMessage(JmsInboundMessageDispatch jmsInboundMessageDispatch) {
+ log.error("jmsInboundMessageDispatch:{}",jmsInboundMessageDispatch);
+ }
+
+ @Override
+ public void onSessionClosed(Session session, Throwable throwable) {
+ log.error("session:{}",throwable);
+ }
+
+ @Override
+ public void onConsumerClosed(MessageConsumer messageConsumer, Throwable throwable) {
+ log.error("messageConsumer:{}",throwable);
+ }
+
+ @Override
+ public void onProducerClosed(MessageProducer messageProducer, Throwable throwable) {
+ log.error("messageProducer:{}",throwable);
+ }
+}
diff --git a/src/main/java/com/example/demo/controller/IndexController.java b/src/main/java/com/example/demo/controller/IndexController.java
new file mode 100644
index 0000000..f443059
--- /dev/null
+++ b/src/main/java/com/example/demo/controller/IndexController.java
@@ -0,0 +1,72 @@
+package com.example.demo.controller;
+
+import cn.hutool.json.JSONUtil;
+import com.aliyun.iot20180120.Client;
+import com.aliyun.iot20180120.models.PubRequest;
+import com.aliyun.iot20180120.models.PubResponse;
+import com.example.demo.dto.VoiceData;
+import io.netty.util.internal.ObjectUtil;
+import lombok.extern.slf4j.Slf4j;
+import org.apache.tomcat.util.codec.binary.Base64;
+import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.web.bind.annotation.GetMapping;
+import org.springframework.web.bind.annotation.PathVariable;
+import org.springframework.web.bind.annotation.RestController;
+
+import javax.jms.*;
+import javax.naming.Context;
+import javax.naming.InitialContext;
+import javax.naming.NamingException;
+import java.util.Hashtable;
+
+@RestController
+@Slf4j
+public class IndexController {
+
+ @Autowired
+ private Client client;
+ private Session session;
+
+ private String iotInstanceId = "iot-06z00hk8iq70r0s";
+
+ @GetMapping("/1")
+ public void index() throws NamingException, JMSException {
+ log.error("gogo");
+ Hashtable hashtable = new Hashtable<>();
+ hashtable.put("queue.QUEUE", "default");
+ hashtable.put("queue.ZYH", "default");
+ hashtable.put(Context.INITIAL_CONTEXT_FACTORY, "org.apache.qpid.jms.jndi.JmsInitialContextFactory");
+
+ Context context = new InitialContext(hashtable);
+ Destination prod = (Destination) context.lookup("ZYH");
+
+ MessageProducer prodocer = session.createProducer(prod);
+
+ prodocer.send(session.createTextMessage("sssss"));
+ log.error("bye.");
+ }
+
+ // http://localhost:8082/msg/zsw38/真的食物/get
+ @GetMapping("/msg/{device}/{content}/{volume}")
+ public String index2(@PathVariable("device") String device,@PathVariable("content") String context,@PathVariable("volume") Integer volume) throws Exception {
+ VoiceData voiceData = new VoiceData();
+ voiceData.setContext(context);
+ voiceData.setVolume(volume);
+
+ String json = JSONUtil.toJsonStr(voiceData);
+
+ String topic = "/hhlz49DDHhl/"+device+"/user/get";
+ PubRequest pubRequest = new PubRequest();
+ pubRequest.setIotInstanceId(iotInstanceId);
+ pubRequest.setDeviceName(device);
+ pubRequest.setMessageContent(Base64.encodeBase64String(json.getBytes()));
+ pubRequest.setQos(0);
+ pubRequest.setProductKey("hhlz49DDHhl");
+ pubRequest.setTopicFullName(topic);
+ PubResponse res = client.pub(pubRequest);
+ log.info("device:{},context:{}",device,json);
+// log.info("body:{}",res.getBody());
+// log.info("status:{}",res.getStatusCode());
+ return res.getBody().getMessageId();
+ }
+}
diff --git a/src/main/java/com/example/demo/dto/VoiceData.java b/src/main/java/com/example/demo/dto/VoiceData.java
new file mode 100644
index 0000000..05f01b0
--- /dev/null
+++ b/src/main/java/com/example/demo/dto/VoiceData.java
@@ -0,0 +1,12 @@
+package com.example.demo.dto;
+
+import lombok.Data;
+
+@Data
+public class VoiceData {
+
+ private String context;
+
+ private Integer volume;
+
+}
diff --git a/src/main/resources/application.yaml b/src/main/resources/application.yaml
new file mode 100644
index 0000000..0884131
--- /dev/null
+++ b/src/main/resources/application.yaml
@@ -0,0 +1,2 @@
+server:
+ port: 8082
\ No newline at end of file
diff --git a/src/test/java/com/example/demo/Demo1ApplicationTests.java b/src/test/java/com/example/demo/Demo1ApplicationTests.java
new file mode 100644
index 0000000..dd22115
--- /dev/null
+++ b/src/test/java/com/example/demo/Demo1ApplicationTests.java
@@ -0,0 +1,13 @@
+package com.example.demo;
+
+import org.junit.jupiter.api.Test;
+import org.springframework.boot.test.context.SpringBootTest;
+
+@SpringBootTest
+class Demo1ApplicationTests {
+
+ @Test
+ void contextLoads() {
+ }
+
+}